/*

   This is a complete assignment set which includes the
   following programs :

	      1> Line Drawing using DDA
	      2> Line Drawing using Bresenham's method
	      3> Circle Drawing DDA .
	      4> Circle Drawing using Bresenhams algorithm.
	      5> Polygon Filling using SCAN LINE METHOD.
	      6> TWO DIMENSIONAL Transformation
	      7> 2-D Clipping (Sutherland & Cohen Algorithm).
	      8> 3D Transformations.


    PROGRAM BY   : G P POTDAR

    DATE WRITTEN : 15/09/99
								*/

/*----------------------------------------------------------------*/

#include<stdio.h>
#include<dos.h>
#include<graphics.h>
#include<conio.h>
#include<math.h>
#include<stdlib.h>
#include<string.h>
#include<iostream.h>


#define line1 printf("\n---------------------------------------------------------------------------------");
#define LINE printf("\n----------------------------------------------------------------------------------");

  union REGS i,o;
  int pattern;
  int sign(float del);
  int inte(float temp);
  int gd=DETECT,gm,button,col=YELLOW,knotk,knotn;
  int xt,yt,ymax=0,ymin=640,xmin=640,xmax=0;
  int code1[4],code2[4];
  int xr,xl;
  int XO,YO;

  const float PI = 3.14159;
  const int N_U_RATOR = 30;	// Numerator of probability
  const int D_N_RATOR = 100;	// Denomenator of probability
  int NUMBER = 7;	// Number of tendrils per cluster
  const float RAD = 3.0;	// Length of straight line segments
  const float DELTHETA = 0.1; // Change in theta (radians)
  const int SEGS = 60;	// Max line segments per tendril
  const int REDUX = 3; 	// How much to divide # of segments
  const int MIN = 1;	// Minimum number of line segments

  /*--------------------end of constant declarations----------------*/

  struct pixl
  {
   int x,y;
  }ponts[10];

  /*

  class cluster
  {
    public :
	void display(int size,int x, int y,int colour);
  };
  class tendril
  {
    public :
	void display(int size, float theta,int x, int y,int colour);
  };
  void cluster::display(int size, int xO, int yO,int colour)
  {
    if(kbhit())  {     return;   }
    else
     {
    for(int i = 0;i<NUMBER;i++)	// for each tendril
   {
    float theta = i * 2*PI/NUMBER;
    int x = xO, y = yO;
    moveto(x,y);
    tendril t;			// make a tendril
    t.display(size,theta,x,y,colour);  // display it
   }
 }
}
void tendril::display(int size,float theta,int x,int y,int colour)
{
  for(int j = 0;j<size;j++)
  {
     int chng = (random(D_N_RATOR)<N_U_RATOR) ? -1 : 1;	// left or right
     theta = theta + chng * DELTHETA;		// new angle
     x = x + RAD * sin(theta);			// x and y of
     y = y + RAD * cos(theta);			// next point
     if(size < 4) setcolor(colour);
     else if(size < 13) setcolor(GREEN);
     else if(size < 40) setcolor(LIGHTGREEN);
     else setcolor(YELLOW);
     lineto(x,y);				// draw line
  }
  if(size > MIN)
  {
     cluster c;		    // if tendril is long enough make new cluster
     int newsize = size/REDUX;	// but smaller then before
     c.display(newsize, x, y,colour);  // display it
  }
}
void rsfill();
void left_right(int yt,int *xl,int *xr);
void fractals()
{
   int colour,style=0,lsize=0;
   randomize();
   int size = SEGS;
   setlinestyle(0,0,3);
   setcolor(11);
   outtextxy(getmaxx()/3,45," Flowers For You  By Vikrant ");
   outtextxy(getmaxx()/3,getmaxy()-30,"   Press Any Key To Exit   ");
   sleep(1);
   setcolor(12);
   rectangle(15,55,getmaxx()-60,getmaxy()-40);
   setviewport(15,55,getmaxx()-60,getmaxy()-40,1);
   while(!kbhit())
   {
   cluster c1;		// define cluster
   XO = getmaxx()/8;
   YO = getmaxy()-150;
   int x = XO, y = YO;
   NUMBER = 8;
   setlinestyle(style,0,lsize);
   if(style == 0||style==1) style++; else style = 0;
   if(lsize <= 2) lsize++; else lsize = 2;
   c1.display(size,x,y,colour); // display the cluster
   XO = getmaxx()-100;
   YO = getmaxy()/3;
   x = XO; y = YO;
   c1.display(size,x,y,colour+1); // display the cluster
   if(!kbhit())
      sleep(3);
   clearviewport();
   if(colour < 15)
      colour++;
   else
   {
      colour = 1;
   }
 }
}

class p_3d
{
	float x,y,z;
	friend _3d;
	friend MATRIX;
};
class p_2d
{
	float x,y;
	friend class _3d;
	friend MATRIX;
};
class _3d
{
	int n;
	float side;
	p_3d *v_3;
	p_2d *v_2;
	float tx,ty,tz;
	friend MATRIX;
	public :
		int assign_3d(void);
		int plot_2d(p_3d,p_3d);
		p_2d conv3_2(p_3d *);
		int init(void);
};
class MATRIX
{
	float mat[5][5];
	class p_3d *v_3d;
	int n1;
	friend _3d;
	public:
		int init(void);
		void mat_manage(void);
		int tran(_3d *);
		int disp(void);
		int plot_2d(p_3d,p_3d);
		p_2d conv3_2(p_3d *);
		void mat_set_iden(void);
		void mat_mul(MATRIX *);
		void scale(float,float,float,p_3d);
		void rotate(float,int);
		void translate(float,float,float);
		void trans_pt(p_3d *);
		void transfer(_3d);
		int disp_out(void);
};


void initmouse()
{
   i.x.ax=0;
   int86(0x33,&i,&o);
}

void show_ptr()
{
  i.x.ax=1;
  int86(0x33,&i,&o);
}

void hide_ptr()
{
   i.x.ax=2;
   int86(0x33,&i,&o);
}

void getmousepos(int*button,int *x,int *y)
{
  i.x.ax=3;
  int86(0x33,&i,&o);
  *button=o.x.bx;
  *x=o.x.cx;
  *y=o.x.dx;
}


void fill(void)
{
  int n,i=0,j;
  setcolor(RED);
   ymax=0;
   xmax=0;
   ymin=640;
   xmin=640;
  line(0,200,591,200);
  gotoxy(10,15);
  cout<<"Enter Polygon Vertices No (max 8) :->  ";
  cin>>n;
  gotoxy(10,16);
  cout<<"To Enter The Points Press A Key ......";
  getch();
  i=0;
  while(i<n)
    {
      delay(100);
      getmousepos(&button,&xt,&yt);
      if(button&1==1)
	{
	   ponts[i].x=xt;
	   ponts[i].y=yt;
	   if(yt>=ymax)
	   ymax=yt;
	  if(yt<=ymin)
	    ymin=yt;
	   if(xt>=xmax)
	     xmax=xt;
	   if(xt<=xmin)
	     xmin=xt;

	   hide_ptr();
	   putpixel(xt,yt,col);
	   show_ptr();
	   gotoxy(10,17+i);
	   cout<<"Point "<<i+1<<" Is ( "<<xt<<" "<<yt<<" )";
	   i++;
	}
    }
    getch();
    i=0;
    setcolor(BLUE);
   for(j=0;j<n-1;j++)
     {
       line(ponts[i].x,ponts[i].y,ponts[i+1].x,ponts[i+1].y);
       i++;
     }

     hide_ptr();
    line(ponts[i].x,ponts[i].y,ponts[0].x,ponts[0].y);
    setcolor(col);
    show_ptr();
    i++;
    outtextxy(10,378,"Click Pattern (0) floodfill & (1) stripped ");
    button=0;
     while(1)
     {
      getmousepos(&button,&i,&j);
       if(button&1==1)
       {
	 if(i>=600&&i<=615)
	   {
	     if(j>=110&&j<=130)
	     {
		pattern=0;
		 break;
	     }
	     if(j>=70&&j<=90)
	     {
		pattern=1;
		break;
	     }
	    pattern=3;

	   }
	  break;
	}
      }



getch();
rsfill();
}
void left_right(int yt,int *xl,int *xr)
{
  int j,flg=0;
 for(j=xmin;j<=xmax;j++)
   {
    if(getpixl(j,yt)==BLUE)
     {
     if(flg==0)
     {
	 *xl=j;
	 flg=1;
     }
     else
       *xr=j;
     }
    }
}
void rsfill()
{
int i,temp;
temp=ymin+1;
do
  {
      left_right(temp,&xl,&xr);
     for(i=xl+1;i<xr;i++)
	putpixel(i,temp,col);
      if(pattern==0)
	  temp=temp+1;
      if(pattern==1)
	 temp=temp+2;

}while(temp<ymax);

}

void find(int x1,int y1,int x2,int y2,int l,int r,int t,int b)
{
	if(y1<t)
		code1[0]=1;
	else
		code1[0]=0;
	if(y1>b)
		code1[1]=1;
	else
		code1[1]=0;
	if(x1<l)
		code1[2]=1;
	else
		code1[2]=0;
	if(x1>r)
		code1[3]=1;
	else
		code1[3]=0;

	if(y2<t)
		code2[0]=1;
	else
		code2[0]=0;
	if(y2>b)
		code2[1]=1;
	else
		code2[1]=0;
	if(x2<l)
		code2[2]=1;
	else
		code2[2]=0;
	if(x2>r)
		code2[3]=1;
	else
		code2[3]=0;
}
void clip(void)
{
	float l,r,t,b,x1[10],y1[10],x2[10],y2[10],i,j,n,k,flag;
	setcolor(RED);
	line(0,240,591,240);
	setcolor(col);
	gotoxy(10,17);
	cout<<"Click The Left-Top & Right-Bottom Corners  : ";
	 while(1)
	  {
	  delay(200);
	  getmousepos(&button,&xt,&yt);
	      if(button&1==1)
	       {
		l=xt;
		t=yt;
		hide_ptr();
		putpixel(xt,yt,15);
		show_ptr();
		gotoxy(55,17);
		cout<<xt;
		gotoxy(59,17);
		cout<<yt;
		break;
	      }
	 }
	 while(1)
	  {
	  delay(200);
	  getmousepos(&button,&xt,&yt);
	      if(button&1==1)
	       {
		r=xt;
		b=yt;
		hide_ptr();
		putpixel(xt,yt,15);
		show_ptr();
		gotoxy(63,17);
		cout<<xt;
		gotoxy(67,17);
		cout<<yt;
		break;
	      }
	 }
       hide_ptr();
	rectangle(l,t,r,b);
      show_ptr();
      gotoxy(10,18);
      cout<<"Enter The Number Of Lines To Be Clipped    :   ";
      cin>>n;
      j=2;
	for(i=0;i<n;i++)
	{
		gotoxy(10,18+j);
		cout << "Click Point P1 ( x , yt )";
		button=0;
		while(1)
		{
		  delay(100);
		  getmousepos(&button,&xt,&yt);
		  if(button&1==1)
		  {
		    x1[i] = xt;
		    y1[i] = yt;
		    hide_ptr();
		    putpixel(xt,yt,15);
		    show_ptr();
		    gotoxy(40,18+j);
		    cout<<xt;
		    gotoxy(44,18+j);
		    cout<<yt;
		    break;
		  }
		}
		j++;
		gotoxy(10,18+j);
		cout << "Click Point P2 ( x , yt )";
		button=0;
		while(1)
		{
		  delay(100);
		  getmousepos(&button,&xt,&yt);
		  if(button&1==1)
		  {
		    x2[i] = xt;
		    y2[i] = yt;
		    hide_ptr();
		    putpixel(xt,yt,15);
		    show_ptr();
		    gotoxy(40,18+j);
		    cout<<xt;
		    gotoxy(44,18+j);
		    cout<<yt;
		    break;
		  }
		}
		j++;
	}

	for(i=0;i<n;i++)
		line(x1[i],y1[i],x2[i],y2[i]);
	getch();
	rectangle(l,t,r,b);
	k=0;
	while(k<n)
	{
		flag=0;
	do
	{
		find(x1[k],y1[k],x2[k],y2[k],l,r,t,b);
		if(code1[0]==0&&code1[1]==0&&code1[2]==0&&code1[3]==0&&code2[0]==0&&code2[1]==0&&code2[2]==0&&code2[3]==0)
		{

			setcolor(MAGENTA);
			line(x1[k],y1[k],x2[k],y2[k]);
			break;
		}
		if(((code1[0]&&code2[0])==1)||((code1[1]&&code2[1])==1)||((code1[2]&&code2[2])==1)||((code1[3]&&code2[3])==1))
			break;
		if(code1[0]==0&&code1[1]==0&&code1[2]==0&&code1[3]==0)
		{
			i=x1[k];
			x1[k]=x2[k];
			x2[k]=i;
			i=y1[k];
			y1[k]=y2[k];
			y2[k]=i;
			for(j=0;j<4;j++)
			{
				i=code1[j];
				code1[j]=code2[j];
				code2[j]=i;
			}
		 }
		 i=0;
		 while(code1[i]!=1)
			i++;
		 switch((int)i)
		 {
		 case 0:
			x1[k]=((t-y1[k])*(x2[k]-x1[k]))/(y2[k]-y1[k])+x1[k];
			y1[k]=t;
			break;
		 case 1:
			x1[k]=((b-y1[k])*(x2[k]-x1[k]))/(y2[k]-y1[k])+x1[k];
			y1[k]=b;
			break;
		 case 2:
			y1[k]=((l-x1[k])*(y2[k]-y1[k]))/(x2[k]-x1[k])+y1[k];
			x1[k]=l;
			break;
		 case 3:
			y1[k]=((r-x1[k])*(y2[k]-y1[k]))/(x2[k]-x1[k])+y1[k];
			x1[k]=r;
			break;
		 }
	   }while(flag==0);
	  k++;
	}
}

int C(int n,int I)
{
  int j,a=1;
  div_t lt;
  for(j=I+1;j<=n;j++)
       a=a*j;
  lt.quot=a;
  for(j=1;j<=n-I;j++)
  lt =div(lt.quot,j);
  return(lt.quot);
}
float blend(int I,int n,float u)
{
  int j;
  float v;
  v=C(n,I);
  for(j=1;j<=I;j++)
    v=v*u;
  for(j=1;j<=(n-I);j++)
     v=v*(1-u);
  return(v);
}
void bezier(float *x,float *y,float *z,float u,int n,float a[][3])
{
 int I;
 float b;
 *x=0;
 *y=0;
 *z=0;
 for(I=0;I<=n;I++)
   {
     b=blend(I,n,u);
     *x=*x+a[I][1]*b;
     *y=*y+a[I][2]*b;
     *z=*z+a[I][3]*b;
   }
}

void doing_bez(void)
{
  float a[4][3],x,y,z;
  int I,count=0,xt,yt;
  setcolor(15);
  rectangle(1,1,639,479);
  setcolor(col);
  settextstyle(TRIPLEX_FONT,HORIZ_DIR,1);
  cout<<"\n\n\n";
  setcolor(CYAN);
  outtextxy(10,450,"      ******  Bezier Curves For 4 Points   ******");
  while(count<=3)
    {
      delay(100);
      getmousepos(&button,&xt,&yt);
      if(button&1==1)
	{
	 gotoxy(2,22+count);
	 cout<<"Point v"<<count+1<<" (x,y) Is :-> "<<xt<<"  "<<yt;
	 a[count][1]=xt;
	 a[count][2]=yt;
	 hide_ptr();
	 setcolor(LIGHTGREEN);
	 circle(xt,yt,2);
	 show_ptr();
	 count++;
	}
      }
  for(I=0;I<=3;I++)
    a[I][3]=0;
    setcolor(col);
  for(I=0;I<=40;I++)
   {
    bezier(&x,&y,&z,(float)(I/40.0),3,a);
    if(I==0)
      moveto(x,y);
    else
      lineto(x,y);
    }
}
int knot(int i)
  {
    if(i<knotk)
       return(0);
    else
      {
       if(i>knotn)
	  return(knotn-knotk+2);
       else
	   return(i-knotk+1);
      }
}
float bblend(int i,int k,float u)
{
   int t;
   float v;
   if(k==1)
     {
       v=0;
       if((knot(i)<=u)&&(u<knot(i+1)))
	 v=1;
     }
     else
	 {
	   v=0;
	   t=knot(i+k-1)-knot(i);
	   if(t!=0)
	      v=((u-knot(i))*bblend(i,k-1,u))/t;
	   t=knot(i+k)-knot(i+1);
	   if(t!=0)
	      v= v+(knot(i+k)-u)*(bblend(i+1,k-1,u)/t);
	  }
       return(v);
}
void bspline(float *x,float *y,float *z,float u,int n,int k,float a[][3])
{
  int i;
  float b;
  knotk=k;
  knotn=n;
  *x=0;
  *y=0;
  *z=0;
  for(i=0;i<=n;i++)
    {
	b=bblend(i,k,u);
	*x=*x+a[i][1]*b;
	*y=*y+a[i][2]*b;
	*z=*z+a[i][3]*b;
    }
}


void doing_bspline(void)
{
  float a[10][3],x,y,z;
  int i,count=0,xt,yt,n;
  settextstyle(TRIPLEX_FONT,HORIZ_DIR,2);
  setcolor(CYAN);
  outtextxy(10,450,"      ******  Bspline Curves For n Control Points   ******");
  cout<<"\n\n\tEnter The Number Of Points max 10 :->\t";
  setcolor(15);
  rectangle(1,1,639,479);
  cin>>n;
  setcolor(col);
  while(count<=n)
    {
      delay(100);
      getmousepos(&button,&xt,&yt);
      if(button&1==1)
	{
	 gotoxy(2,18+count);
	 cout<<"v"<<count+1<<" (x,y) Is :-> "<<xt<<"  "<<yt;
	 a[count][1]=xt;
	 a[count][2]=yt;
	 hide_ptr();
	 setcolor(LIGHTBLUE); //=>Bspline Curve
	 circle(xt,yt,2);
	 show_ptr();
	 count++;
	}
      }
  for(i=0;i<=n;i++)
    a[i][3]=0;
    setcolor(col);
  for(i=0;i<n*10;i++)
   {
   bspline(&x,&y,&z,(float)(i/(float)(n*10)),n,n+1,a);
   if(i==0)
       moveto(x,y);
    else
     {
      hide_ptr();
      lineto(x,y);
      show_ptr();
     }
    }
}
void linedda(int col)
{
 int but2=0,x1,y1,x2,y2,i=0,but1;
 float len,delx,dely,x,y;
 delay(500);
 while(1)
    {
     getmousepos(&but1,&x1,&y1);
     if(but1&1==1)
       break;
    }
 hide_ptr();
 setcolor(RED);
 circle(x1,y1,2);
 show_ptr();
 delay(500);
 while(1)
    {
     getmousepos(&but2,&x2,&y2);
     if(but2&1==1)
     break;
   }
 hide_ptr();
 circle(x2,y2,2);
 show_ptr();
 setcolor(col);
 if(abs(x2-x1)>=abs(y2-y1))
     len=abs(x2-x1);
 else
     len=abs(y2-y1);
 delx = (x2-x1)/len;
 dely = (y2-y1)/len;
 x=x1+(0.5*sign(delx));
 y=y1+(0.5*sign(dely));
 while(i<=len)
   {
     hide_ptr();
     delay(2);
     putpixel(inte(x),inte(y),col);
     show_ptr();
     x=x+delx;
     y=y+dely;
     i++;
   }
}

int sign(float del)
{
  if(del<0)
    return(-1);
  if(del==0)
     return(0);
  if(del>0)
     return(1);
return(0);
}

int inte(float temp)
{
double frac,integer;
  frac=modf(temp,&integer);
if(frac>0.5)
   return(integer);
else
   return(temp-frac);
}

void lineb(int col)
{
 int x1,y1,x2,y2,s1,s2,but1=0,but2=0,interchange=0;
 float temp,delx,dely,x,y,err,i=0;
 delay(500);
 while(1)
    {
     getmousepos(&but1,&x1,&y1);
     if(but1&1==1)
       break;
    }
 setcolor(CYAN);
 hide_ptr();
 circle(x1,y1,2);
 show_ptr();
 delay(500);
 while(1)
    {
     getmousepos(&but2,&x2,&y2);
     if(but2&1==1)
     break;
   }
 hide_ptr();
 circle(x2,y2,2);
 show_ptr();
 setcolor(col);
 x=x1;
 y=y1;
 delx=abs(x2-x1);
 dely=abs(y2-y1);
 s1=sign(x2-x1);
 s2=sign(y2-y1);
 if(dely>delx)
  {
     temp=delx;
     delx=dely;
     dely=temp;
    interchange=1;
  }
 err=(2*dely)-delx;
 for(i=0;i<=delx;i++)
    {
       delay(2);
       hide_ptr();
       putpixel(x,y,col);
       show_ptr();
	  while(err>=0)
	     {
		if(interchange==1)
		    x=x+s1;
		else
		    y=y+s2;
		err=err-2*delx;
	      }
	   if(interchange==1)
	      y=y+s2;
	   else
	      x=x+s1;
	   err=err+(2*dely);
    }
}

void cirb(int col)
{
  float xi=0,yi,R,deli,limit,delta;
  int xt,yt;
  setcolor(col);
  outtextxy(170,450,"Click The Circumferential Point ");
  circle(getmaxx()/2,getmaxy()/2,1);
  delay(100);
  do
  {
    getmousepos(&button,&xt,&yt);
     if(button&1==1)
	   break;
 }while(1);
 R=(getmaxx()/2-xt)*(getmaxx()/2-xt)+(getmaxy()/2-yt)*(getmaxy()/2-yt);
 R=pow(R,0.5);
  yi=R;
  deli=2*(1-R);
  limit=0;
  while(1)
    {
       hide_ptr();
       putpixel(xi+getmaxx()/2,yi+getmaxy()/2,col);
       putpixel(getmaxx()/2-xi,yi+getmaxy()/2,col);
       putpixel(getmaxx()/2+xi,getmaxy()/2-yi,col);
       putpixel(getmaxx()/2-xi,getmaxy()/2-yi,col);
       delay(10);
       show_ptr();
       if(yi<=limit)
	    break;
	if(deli<0)
	   {
	     delta = 2*deli + 2*yi - 1;
	       if(delta<=0)
		 {
		    xi=xi+1;
		    deli=deli+2*xi+1;
		  }
		else
		  {
		    xi=xi+1;
		    yi=yi-1;
		    deli=deli+2*xi-2*yi+2;
		  }
	     }
	else
	    {
	    if(deli>0)
	      {
		 if((2*deli-2*xi-1)<=0)
		   {
		      xi=xi+1;
		      yi=yi-1;
		      deli=deli+2*xi-2*yi+2;
		    }
		   else
		     {
		       yi=yi-1;
		       deli=deli-2*yi+1;
		     }
	       }
	    else
		{
		      xi=xi+1;
		      yi=yi-1;
		      deli=deli+2*xi-2*yi+2;
		  }
	     }

       }
  }
void disp_axes(void)
{
	      setcolor(WHITE);
	      rectangle(0,40,591,479);
	      setfillstyle(SOLID_FILL,BLACK);
	      floodfill(200,200,WHITE);
	      setcolor(col);
	      line(590/2,45,590/2,500);
	      line(0,250,590,250);
	      circle(590/2,250,3);
	      outtextxy(getmaxx()/2+2,getmaxy()/2+2,"(0,0)");
}

void td(void)
{
	int pick=0,vert,*p,*q,*r,*s,i,j=0,sx,sy;
	double angle;
	char direction;
	while(pick!=4)
	{
	      setcolor(WHITE);
	      rectangle(0,40,591,479);
	      setfillstyle(SOLID_FILL,BLACK);
	      floodfill(1,41,WHITE);
		gotoxy(10,5);
		cout << "The menu :->  ";
		gotoxy(10,6);
		cout << "1> Create a Two dimensional figure  ";
		gotoxy(10,7);
		cout << "2> Scaling                          ";
		gotoxy(10,8);
		cout << "3> Rotation                         ";
		gotoxy(10,9);
		cout << "4> Exit                             ";
		gotoxy(10,10);
		cout << "Click your choice                    ";
		cin >> pick;
		setcolor(col);
		switch(pick)
		{
		case 1:
			gotoxy(10,12);
			cout << "Enter how many vertices   ";
			cin >> vert;
			p=(int *)(malloc(sizeof(int)*vert*2+4));
			q=(int *)(malloc(sizeof(int)*vert*2+4));
			r=(int *)(malloc(sizeof(int)*vert*2+4));
			s=(int *)(malloc(sizeof(int)*vert*2+4));
			for(i=0;i<vert;i++)
			{
				gotoxy(10,13+i);
				cout << " Enter  ( X"<<i+1<<" , Y"<<i+1<<")"<< "\t";
				cin >> p[j] >> p[j+1];
				q[j]=p[j];
				q[j+1]=p[j+1];
				r[j]=q[j];
				s[j]=q[j];
				r[j+1]=q[j+1];
				s[j+1]=q[j+1];
				p[j]=p[j]+(590/2);
				if(p[j+1]<0)
					p[j+1]=(-1*p[j+1])+(500/2);
				else
					p[j+1]=(500/2)-p[j+1];
				j=j+2;
			}
			p[j]=p[0];
			p[j+1]=p[1];
			q[j]=p[j];
			q[j+1]=p[j+1];
			r[j]=q[j];
			r[j+1]=q[j+1];
			disp_axes();
			drawpontsy(vert+1,p);
			getch();
			 setcolor(WHITE);
			rectangle(0,40,591,479);
			setfillstyle(SOLID_FILL,BLACK);
			 floodfill(1,41,WHITE);
			setcolor(col);
			break;
		case 2:
			cout << "Enter the scaling factor sx \t";
			cin >> sx;
			cout << "Enter the scaling factor sy \t";
			cin >> sy;
			j=0;
			for(i=0;i<vert;i++)
			{
				q[j]=q[j]*sx;
				q[j+1]=q[j+1]*sy;
				q[j]=q[j]+(590/2);
				if(q[j+1]<0)
					q[j+1]=(-1*q[j+1])+(500/2);
				else
					q[j+1]=(500/2)-q[j+1];
				j=j+2;
			}
			q[j]=q[0];
			q[j+1]=q[1];
			cleardevice();
			disp_axes();
			drawpontsy(vert+1,q);
			getch();
			break;
		case 3:
			cout << "Enter the angle by which you have to rotate \t ";
			cin  >> angle;
			cout << "Which direction you want to rotate in ? \n";
			cout << "Clockwise / Anticlockwise\n";
			cout << "Enter c for clockwise & a for anticlockwise \t";
			cin  >> direction;
			switch(direction)
			{
			case 'c':
				 j=0;
				 for(i=0;i<vert;i++)
				 {
					r[j]=(int)(r[j]*cos(angle)+r[j+1]*(-1*sin(angle)));
					r[j+1]=(int)(r[j]*sin(angle)+r[j+1]*(cos(angle)));
					r[j]=r[j]+(590/2);
					if(r[j+1]<0)
						r[j+1]=(-1*r[j+1])+(500/2);
					else
						r[j+1]=(500/2)-r[j+1];
					j=j+2;
				  }
				  r[j]=r[0];
				  r[j+1]=r[1];
				  break;
			case 'a':
				 j=0;
				 for(i=0;i<vert;i++)
				 {
					r[j]=(int)(r[j]*cos(angle)+r[j+1]*(sin(angle)));
					r[j+1]=(int)(r[j]*(-1*sin(angle))+r[j+1]*(cos(angle)));
					r[j]=r[j]+(590/2);
					if(r[j+1]<0)
						r[j+1]=(-1*r[j+1])+(500/2);
					else
						r[j+1]=(500/2)-r[j+1];
					j=j+2;
				  }
				  r[j]=r[0];
				  r[j+1]=r[1];
				  break;
			}
			cleardevice();
			disp_axes();
			drawpontsy(vert+1,r);
			getch();
			break;
		case 4:
			break;
		}
	}
}
void MATRIX ::transfer(_3d fig)
{
	n1=fig.n;
	v_3d=new(p_3d[2+n1]);
	for(int i=1;i<=n1;i++)
	{
		v_3d[i].x=fig.v_3[i].x;
		v_3d[i].y=fig.v_3[i].y;
		v_3d[i].z=fig.v_3[i].z;
	}
	return;
}
void MATRIX :: mat_set_iden(void)
{
	int r,c;
	for(r=1;r<=4;r++)
	{
		for(c=1;c<=4;c++)
		{
			if(r==c)
			{
				mat[r][c]=1;
			}
			else
			{
				mat[r][c]=0;
			}
		}
	}
	return;
}
void MATRIX :: mat_mul(MATRIX *m)
{
	float result[5][5];
	int i,j,k;
	for(i=1;i<=4;i++)
	{
		for(k=1;k<=4;k++)
		{
			result[i][k]=0;
			for(j=1;j<=4;j++)
			{
				result[i][k]+=mat[i][j]*m->mat[j][k];
			}
		}
	}
	for(i=1;i<=4;i++)
	{
		for(k=1;k<=4;k++)
		{
			m->mat[i][k]=result[i][k];
		}
	}
	return;
}

void MATRIX :: scale(float sx,float sy,float sz,p_3d refpt)
{
	mat[1][1]=sx;
	mat[1][4]=(1-sx)*refpt.x;
	mat[2][2]=sy;
	mat[2][4]=(1-sy)*refpt.y;
	mat[3][3]=sz;
	mat[3][4]=(1-sz)*refpt.z;
	return;
}
void MATRIX :: rotate(float a,int ck)
{
	a*=M_PI/180;
	switch (ck)
	{
		case 3:
			mat[1][1]=cos(a);
			mat[1][2]=-sin(a);
			mat[2][1]=sin(a);
			mat[2][2]=cos(a);
			return;
		case 1:
			mat[2][2]=cos(a);
			mat[2][3]=-sin(a);
			mat[3][2]=sin(a);
			mat[3][3]=cos(a);
			return;
		case 2:
			mat[1][1]=cos(a);
			mat[1][3]=sin(a);
			mat[3][1]=-sin(a);
			mat[3][3]=cos(a);
			return;
	}
}
void MATRIX :: translate(float tx,float ty,float tz)
{
	mat[1][4]=tx;
	mat[2][4]=ty;
	mat[3][4]=tz;
	return;
}
void MATRIX :: trans_pt(p_3d *pt)
{
	float temp;
	p_3d p;
	p.y=mat[2][1]*pt->x+mat[2][2]*pt->y+mat[2][3]*pt->z+mat[2][4];
	p.x=mat[1][1]*pt->x+mat[1][2]*pt->y+mat[1][3]*pt->z+mat[1][4];
	p.z=mat[3][1]*pt->x+mat[3][2]*pt->y+mat[3][3]*pt->z+mat[3][4];
	pt->z=p.z;
	pt->x=p.x;
	pt->y=p.y;
	return;
}
void MATRIX ::mat_manage(void)
{
	MATRIX Mat,m;
	char opt;
	int i,ck,ch;
	p_3d refpt;
	float sx,sy,sz,tx,ty,tz,theta;
	do
	{
		setcolor(WHITE);
		rectangle(0,40,591,479);
		setfillstyle(SOLID_FILL,BLACK);
		floodfill(200,200,WHITE);
		setcolor(col);
		gotoxy( 2,15);
		cout<<"1.Scaling.";
		gotoxy( 2,16);
		cout<<"2.Translation.";
		gotoxy( 2,17);
		cout<<"3.Rotation.";
		gotoxy( 2,18);
		cout<<"4.End Of Transformations";
		gotoxy( 2,19);
		cout<<"Enter your option..:";
		cin>>ch;
		setcolor(col);
		switch(ch)
		{
			case 1:
			       gotoxy( 2,22);
				cout <<"Enter Sx Sy Sz :->  ";
				cin>>sx>>sy>>sz;
				gotoxy(2,23);
				cout <<"Enter reference Point : (x,y,z) ";
				cin>>refpt.x>>refpt.y>>refpt.z;

				for(i=1;i<=n1;i++)
				{
					Mat.mat_set_iden();
					m.mat_set_iden();
					m.scale(sx,sy,sz,refpt);
					m.mat_mul(&Mat);
					Mat.trans_pt(&v_3d[i]);
				}
				disp();
				break;
			case 2:
			       gotoxy(2,22);
				cout <<"Enter Tx Ty Tz :->  ";
				cin>>tx>>ty>>tz;
				for(i=1;i<=n1;i++)
				{
					Mat.mat_set_iden();
					m.mat_set_iden();
					m.translate(tx,ty,tz);
					m.mat_mul(&Mat);
					Mat.trans_pt(&v_3d[i]);
				}
				disp();
				break;
			case 3:
			       gotoxy(2,22);
				cout <<"\Enter the Value Theta " ;
				cin>>theta;
				gotoxy(2,23);
				cout <<"1.About x-axis.     2>.About y-axis.    3>.About z-Axis   ";
				cin>>ck;
				for(i=1;i<=n1;i++)
				{
					Mat.mat_set_iden();
					m.mat_set_iden();
					m.rotate(theta,ck);
					m.mat_mul(&Mat);
					Mat.trans_pt(&v_3d[i]);
				}
				disp();
				break;
		}
		getch();
		gotoxy(2,24);
		cout<<"Continue....(Y/N)   ";
		cin>>opt;

	}
	while(opt!='n');
	getch();
	return;
}

int MATRIX :: disp(void)
{
	init();
	plot_2d(v_3d[1],v_3d[2]);
	plot_2d(v_3d[2],v_3d[3]);
	plot_2d(v_3d[3],v_3d[4]);
	plot_2d(v_3d[4],v_3d[1]);
	plot_2d(v_3d[4],v_3d[5]);
	plot_2d(v_3d[5],v_3d[6]);
	plot_2d(v_3d[6],v_3d[3]);
	plot_2d(v_3d[5],v_3d[8]);
	plot_2d(v_3d[8],v_3d[1]);
	plot_2d(v_3d[8],v_3d[7]);
	plot_2d(v_3d[7],v_3d[2]);
	plot_2d(v_3d[7],v_3d[6]);
	return 0;
}


p_2d _3d :: conv3_2(p_3d *p)
{
	p_2d p1;
	p1.x=p->x-p->y*cos(M_PI/6);
	p1.y=p->z-p->y*sin(M_PI/6);
	return p1;
}
p_2d MATRIX :: conv3_2(p_3d *p)
{
	p_2d p1;
	p1.x=p->x-p->y*cos(M_PI/6);
	p1.y=p->z-p->y*sin(M_PI/6);
	return p1;
}

int _3d :: plot_2d(p_3d p1,p_3d p2)
{
	p_2d p3,p4;
	float x_mid=getmaxx()/2;
	float y_mid=getmaxy()/2;
	p3=conv3_2(&p1);
	p4=conv3_2(&p2);
	line(x_mid+p3.x,y_mid-p3.y,x_mid+p4.x,y_mid-p4.y);
	getch();
	return 0;
}
int MATRIX :: plot_2d(p_3d p1,p_3d p2)
{
	p_2d p3,p4;
	float x_mid=getmaxx()/2;
	float y_mid=getmaxy()/2;
	p3=conv3_2(&p1);
	p4=conv3_2(&p2);
	line(x_mid+p3.x,y_mid-p3.y,x_mid+p4.x,y_mid-p4.y);
	getch();
	return 0;
}

int _3d :: init(void)
{
	p_3d p1,p2;
	p1.x=p1.y=p1.z=0;
	p2.x=p2.y=0;p2.z=200;
	plot_2d(p1,p2);
	p2.x=p2.z=0;p2.y=200;
	plot_2d(p1,p2);
	p1.x=p1.y=p1.z=0;
	p2.z=p2.y=0;p2.x=200;
	plot_2d(p1,p2);
	return 0;
}
int MATRIX :: init(void)
{
	p_3d p1,p2;
	p1.x=p1.y=p1.z=0;
	p2.x=p2.y=0;p2.z=200;
	plot_2d(p1,p2);
	p2.x=p2.z=0;p2.y=200;
	plot_2d(p1,p2);
	p1.x=p1.y=p1.z=0;
	p2.z=p2.y=0;p2.x=200;
	plot_2d(p1,p2);
	return 0;
}

int _3d :: assign_3d(void)
{
	n=8;
	v_3=new(p_3d[n+2]);
	gotoxy(1,24);
	cout<<"Enter side of the cube..:";
	cin>>side;
	v_3[1].x=0;v_3[1].y=0;v_3[1].z=side;
	v_3[2].x=side;v_3[2].y=0;v_3[2].z=side;
	v_3[3].x=side;v_3[3].y=0;v_3[3].z=0;
	v_3[4].x=0;v_3[4].y=0;v_3[4].z=0;
	v_3[5].x=0;v_3[5].y=side;v_3[5].z=0;
	v_3[6].x=side;v_3[6].y=side;v_3[6].z=0;
	v_3[7].x=side;v_3[7].y=side;v_3[7].z=side;
	v_3[8].x=0;v_3[8].y=side;v_3[8].z=side;
	init();
	plot_2d(v_3[1],v_3[2]);
	plot_2d(v_3[2],v_3[3]);
	plot_2d(v_3[3],v_3[4]);
	plot_2d(v_3[4],v_3[1]);
	plot_2d(v_3[4],v_3[5]);
	plot_2d(v_3[5],v_3[6]);
	plot_2d(v_3[6],v_3[3]);
	plot_2d(v_3[5],v_3[8]);
	plot_2d(v_3[8],v_3[1]);
	plot_2d(v_3[8],v_3[7]);
	plot_2d(v_3[7],v_3[2]);
	plot_2d(v_3[7],v_3[6]);
	getch();
	return 0;
}

void threed(void)
{
	_3d fig;
	MATRIX m;
	setcolor(col);
	m.mat_set_iden();
	fig.assign_3d();
	m.transfer(fig);
	m.mat_manage();
	return;
}

void main()
{
  int x,y;
  initgraph(&gd,&gm,"c:\\turboc3\\bgi");
  rectangle(0,0,getmaxx(),getmaxy());
  cout<<"\n  Quit   Line<DDA>  \tLine<B'Ham>  \tCircle<B'Ham>   Bezier Curve   Bspline ";
  line;
  line(0,40,getmaxx(),40);
  line(591,40,591,478);
  line(591,430,getmaxx(),430);
  setcolor(LIGHTBLUE);
  outtextxy(595,435,"Clip");
  setcolor(15);
  line(591,450,getmaxx(),450);
  setcolor(LIGHTRED);
  outtextxy(595,460,"Fill");
  setcolor(15);
  line(591,390,getmaxx(),390);
  setcolor(LIGHTGREEN);
  outtextxy(595,405,"2DTrans");
  setcolor(15);
  line(591,360,getmaxx(),360);
  setcolor(MAGENTA);
  outtextxy(595,370,"Fractals");
  setcolor(15);
  line(591,340,getmaxx(),340);
  setcolor(CYAN);
  outtextxy(595,345,"3d trans");
  setcolor(15);
  rectangle(0,0,getmaxx(),getmaxy());
  setcolor(LIGHTRED);
  rectangle(600,300,615,320);
  setfillstyle(SOLID_FILL,LIGHTRED);
  floodfill(610,310,LIGHTRED);
  setcolor(LIGHTGREEN);
  rectangle(600,270,615,290);
  setfillstyle(SOLID_FILL,LIGHTGREEN);
  floodfill(610,280,LIGHTGREEN);
  setcolor(LIGHTBLUE);
  rectangle(600,240,615,260);
  setfillstyle(SOLID_FILL,LIGHTBLUE);
  floodfill(610,250,LIGHTBLUE);
  setcolor(YELLOW);
  rectangle(600,210,615,230);
  setfillstyle(SOLID_FILL,YELLOW);
  floodfill(610,220,YELLOW);
  setcolor(WHITE);
  rectangle(600,180,615,200);
  setfillstyle(SOLID_FILL,WHITE);
  floodfill(610,190,WHITE);
  setcolor(WHITE);
  rectangle(600,150,615,170);
  setfillstyle(SOLID_FILL,BLACK);
  floodfill(610,160,WHITE);
  setcolor(WHITE);
  line(591,140,getmaxx(),140);
  rectangle(600,110,615,130);
  setfillstyle(SOLID_FILL,col);
  floodfill(610,120,WHITE);
  setcolor(WHITE);
  rectangle(600,70,615,90);
  setfillstyle(LINE_FILL,col);
  floodfill(610,80,WHITE);
  initmouse();
  show_ptr();
  while(1)
    {
     while(1)
     {
      getmousepos(&button,&x,&y);
       if(button&1==1)
       {
	 if(x>=590&&x<=getmaxx())
	   {
	     if(y>=450&&y<=getmaxy())
	      {
		fill();
	       }
	     if(y>=430&&y<=449)
	      {
		clip();
	       }
	     if(y>=390&&y<=429)
	      {
		td();
	       }
	      if(y>=360&&y<=389)
		{
		  fractals();
		}
	      if(y>=340&&y<=359)
		{
		  threed();
		}
	   }
	if(x>=600&&x<=615)
	  {
	    if(y>=300&&y<=320)
	      col=LIGHTRED;
	    if(y>=270&&y<=290)
	      col=LIGHTGREEN;
	    if(y>=240&&y<=260)
	      col=LIGHTBLUE;
	    if(y>=210&&y<=230)
	      col=YELLOW;
	    if(y>=180&&y<=200)
	      col=WHITE;
	    if(y>=150&&y<=170)
	    {
	      setcolor(WHITE);
	      rectangle(0,40,591,479);
	      setfillstyle(SOLID_FILL,BLACK);
	      floodfill(200,200,WHITE);
	    }

	   }
	 }
       break;
       }

      getmousepos(&button,&x,&y);
      if(button&1==1)
	{
	  if(y>=0&&y<=35)
	     {
		if(x>=20&&x<=69)
		{closegraph();
		  exit(0);
		}
		if(x>=70&&x<=133)
		    linedda(col);
		else
		    {
			if(x>=193&&x<=291)
			    lineb(col);
			else
			     {
				if(x>=315&&x<=426)
				  cirb(col);
				else
				  {
				    if(x>=428&& x<=539)
					doing_bez();
				    else
				       doing_bspline();
				  }

			     }
		       }
		  }
	   }

    }
}